var facebooktranslateTabsListener = {
	QueryInterface: function( aIID ) {
		if ( aIID.equals(Components.interfaces.nsIWebProgressListener) ||
         aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
         aIID.equals(Components.interfaces.nsISupports) ) {
			return this;
		}
		throw Components.results.NS_NOINTERFACE;
	},
	
	onLocationChange: function(aEvent, aProgress, aRequest, aURI) {
		if( ( /.*\.facebook\.com.*/.test( aURI.spec ) ) ) {
			facebooktranslate.setIntervals( aEvent );
		} else {
			clearInterval( facebooktranslate.intervalID );
			clearInterval( facebooktranslate.intervalBlurbID );
			clearInterval( facebooktranslate.intervalAdsID );
		}
      	return 0;
	},
	
	onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) { return 0;},
	onProgressChange: function(aWebProgress, aRequest, curSelf, maxSelf, curTot, maxTot) { return 0;},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) { return 0;},
	onSecurityChange: function(aWebProgress, aRequest, aState) { return 0;}
};

var facebooktranslate = {
	SEP: " &#183; ",
	intervalID: null,
	intervalBlurbID: null,
	intervalAdsID: null,
	
	onFirefoxLoad: function( event ) {
		//Components.utils.import("resource://facebook-translate/content/JSON.js", facebooktranslate);
		
		var doc = event.originalTarget;
		var appcontent = document.getElementById("appcontent");
		var tc = gBrowser.tabContainer;
		var contentdoc = gBrowser.selectedBrowser.contentDocument;
		if( appcontent ) {
			appcontent.addEventListener("DOMContentLoaded", facebooktranslate.onPageLoad, false);
			//appcontent.addEventListener("TabClose", facebooktranslate.onTabClose, false);
			appcontent.addEventListener("TabSelect", facebooktranslate.onTabSelect, false);
		}
		//gBrowser.addTabsProgressListener( facebooktranslateTabsListener );
		
		// Inject my love.. yeah, I'm lazy like that :)
		(function(loader) {
			loader.loadSubScript("chrome://facebook-translate/content/jquery-1.4.2.min.js", facebooktranslate);
		})(
			Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService( Components.interfaces.mozIJSSubScriptLoader )
		);
	},

	onPageLoad: function( aEvent ) {
		facebooktranslate.isFB( aEvent );
	},

	onTabSelect: function( aEvent ) {
		//facebooktranslate.isFB( aEvent );
		var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService).
					getBranch("extensions.facebook-translate.");
		var debugMode = prefs.getBoolPref("debug");
		var basedomain = gBrowser.selectedBrowser.contentDocument.domain.replace(/^www[^.]*./, "");
		if( basedomain == 'facebook.com' ) {
			//aConsoleService.logStringMessage( 'FBTranslate: Interval on' );
			facebooktranslate.setIntervals( aEvent );
		} else {
			//aConsoleService.logStringMessage( 'FBTranslate: Interval off' );
			clearInterval( facebooktranslate.intervalID );
			clearInterval( facebooktranslate.intervalBlurbID );
			clearInterval( facebooktranslate.intervalAdsID );
		}
	},
	
	setIntervals: function( aEvent ) {
		var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		
		//aConsoleService.logStringMessage( 'FBTranslate: Pre Interval On' );
		facebooktranslate.intervalID = window.setInterval(function() {
			facebooktranslate.addMarkup(gBrowser.selectedBrowser.contentDocument, aEvent);
		}, 2000);
		
		/*
		 * TODO: use a nsITimerCallback compatible interface for the callbacks
		 */
		/*var event = { notify: function(functimer) { facebooktranslate.addMarkup(gBrowser.selectedBrowser.contentDocument, aEvent); } }
		var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		timer.initWithCallback(event, 2000, Components.interfaces.nsITimer.TYPE_REPEATING_PRECISE);*/
	
		window.setTimeout(function(){
			facebooktranslate.addBookmarkMarkup(gBrowser.selectedBrowser.contentDocument, aEvent);
		}, 500);
		
		facebooktranslate.processTranslateClicks( gBrowser.selectedBrowser.contentDocument, aEvent );
		
		facebooktranslate.intervalBlurbID = window.setInterval(function(){
			facebooktranslate.addBlurbMarkup(gBrowser.selectedBrowser.contentDocument, aEvent);
		}, 2000);
		
		/*window.setTimeout(function(){
			facebooktranslate.addSidebarMarkup(gBrowser.selectedBrowser.contentDocument, aEvent);
		}, 2000);*/
		
		facebooktranslate.intervalAdsID = window.setInterval(function(){
			facebooktranslate.addSidebarMarkup(gBrowser.selectedBrowser.contentDocument, aEvent);
		}, 2000);
	},
	
	isFB: function( aEvent ) {
		var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		var vsBrowser = gBrowser;
		var vsURL;
		
		eventDocument = aEvent.originalTarget;
		currentDocument = gBrowser.selectedBrowser.contentDocument;
		
		if (eventDocument != currentDocument)
			return;

		vsURL = currentDocument.domain;
		if (vsURL == null)
			return;
				
		basedomain = vsURL.replace(/^www[^.]*./, "");
		//if( ( /.*\.facebook\.com.*/.test( vsURL ) ) ) {
		if ( basedomain == 'facebook.com' ) {
			//clearInterval( facebooktranslate.intervalID );
			
			facebooktranslate.setIntervals( aEvent );
			return true;
			
		} else {
			clearInterval( facebooktranslate.intervalID );
			clearInterval( facebooktranslate.intervalBlurbID );
			clearInterval( facebooktranslate.intervalAdsID );
			return false;
		}
	},
	
	addMarkup: function( doc, aEvent ) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService).
					getBranch("extensions.facebook-translate.");
		var debugMode = prefs.getBoolPref("debug");
		var vsURL = gBrowser.selectedBrowser.contentDocument.domain;
		if (vsURL == null)
			return;
			
		basedomain = vsURL.replace(/^www[^.]*./, "");
		
		if( basedomain == 'facebook.com' ) {
			if( debugMode == true ) {
				var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				aConsoleService.logStringMessage( 'FBTranslate: Markup for ' + gBrowser.selectedBrowser.contentDocument.domain );
			}
			facebooktranslate.getTranslateLinkObject( doc, aEvent );
		}
	},
	
	addBookmarkMarkup: function( doc, aEvent ) {
		var strings = document.getElementById("facebook-translate-strings");
		var optionsLink = strings.getString('optionsLink');
		var hasOptLink = jQuery('#bookmarks_menu ul.uiSideNav #fbtranslateoptionlink', doc);
		
		if( hasOptLink.length < 1 &&facebooktranslate.getFBSection(doc) == 'home' ) {
			var imgclass = jQuery('#bookmarks_menu ul.uiSideNav li:last span:eq(0) i', doc).attr('class');
			jQuery('#bookmarks_menu ul.uiSideNav', doc).prepend('<li class="key-apps"><a href="#" class="item fbtranslateoptionlink" id="fbtranslateoptionlink"><span class="imgWrap"><i class="' + imgclass + '" style="background-image:url(http://www.schloebe.de/extern/facebooktranslate/ico_16.png);background-position:top left;"></i></span><span>' + optionsLink + '</span></span></li>');
		}
	},
	
	addBlurbMarkup: function( doc, event ) {
		var hasLeftCol = jQuery('#left_column #profile_blurb', doc);
		var linkSet = jQuery('#profile_blurb .fbtranslateblurbactionlink', doc);
		
		if( hasLeftCol.length < 1 )
			clearInterval( facebooktranslate.intervalBlurbID );
		
		if( hasLeftCol.length > 0 && linkSet.length < 1 )
			jQuery('#profile_blurb .text_wrapper', doc).after( facebooktranslate.getTranslateLink( false, 'fbtranslateblurbactionlink' ) );
		else
			clearInterval( facebooktranslate.intervalBlurbID );
	},
	
	addSidebarMarkup: function( doc, event ) {
		var hasAdCol = jQuery('#sidebar_ads', doc);
		var hasFBTCol = jQuery('#fbt-news', doc);
		
		if ( hasAdCol.length > 0 && hasFBTCol.length < 1 ) {
			var httpRequest = null;
			var randomnumber = Math.floor(Math.random()*101);
			var fullUrl = "http://www.schloebe.de/extern/facebooktranslate/fbtgetsidebar.html" + "?" + randomnumber;
			
			function contentReceived() {
				var output = httpRequest.responseText;
					
				if (output.length) {
					output = output.replace(/\W*$/, "");
	
					jQuery('#sidebar_ads', doc).prepend( output );
				}
			}
			
			httpRequest = new XMLHttpRequest();
		
			httpRequest.open("GET", fullUrl, true);
			httpRequest.onload = contentReceived;
			httpRequest.send(null);
		} else {
			clearInterval( facebooktranslate.intervalAdsID );
		}
	},
	
	processTranslateClicks: function( doc, aEvent ) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService).
					getBranch("extensions.facebook-translate.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		prefs.addObserver("", this, false);
		var currLocale = prefs.getCharPref("localepref");
		
		var strings = document.getElementById("facebook-translate-strings");
		var untranslateLink = strings.getString('untranslateLink');
		
		jQuery('.fbtranslateactionlink', doc).live('click', function() {
			var _self = this;
			if( facebooktranslate.getFBSection( doc ) == 'profile' ) {
				var gText = jQuery( this, doc ).parentsUntil('#profile_minifeed').find('.UIStory_Message').text();
				var gTextRevert = jQuery( this, doc ).parentsUntil('#profile_minifeed').find('.UIStory_Message').html();
			} else if( facebooktranslate.getFBSection( doc ) == 'home' ) {
				var gText = jQuery( this, doc ).parentsUntil('.UIImageBlock').find('.uiStreamMessage').text();
				var gTextRevert = jQuery( this, doc ).parentsUntil('.UIImageBlock').find('.uiStreamMessage').html();
			}
			var fbtrid = facebooktranslate.md5( gTextRevert );
			var gUrl = 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&format=text&langpair=%7C' + currLocale + '&q=' + encodeURIComponent( gText );
			
			jQuery.getJSON(gUrl,
				function( data ) {
					if( facebooktranslate.processResponseDataErrors( doc, data, _self, gTextRevert, fbtrid, 0 ) === false )
						return;
					
					if( data.responseData.translatedText != 'null' && data.responseStatus == 200 ) {
						if( facebooktranslate.getFBSection( doc ) == 'profile' ) {
							var transText = jQuery( _self, this ).hide().parent().parent().parent().find('.UIStory_Message').html( data.responseData.translatedText );
							jQuery.data(doc, "fbtrid" + fbtrid, gTextRevert);
						} else if( facebooktranslate.getFBSection( doc ) == 'home' ) {
							jQuery( _self, this ).hide().parent().parent().parent().find('.uiStreamMessage').html( data.responseData.translatedText );
							jQuery.data(doc, "fbtrid" + fbtrid, gTextRevert);
						}
					} else {
						alert('Could not translate text!');
					}
			});
			return false;
		});
		
		jQuery('.fbtranslatecommentactionlink', doc).live('click', function( event ) {
			var _self = this;
			//var gText = jQuery( this, doc ).parent().parent().parent().find('.commentContent').text();
			var gText = jQuery( this, doc ).parent().parent().parent().find('.commentContent').contents().eq(1).text();
			var gTextRevert = jQuery( this, doc ).parent().parent().parent().find('.commentContent').contents().eq(1).text();
			var fbtrid = facebooktranslate.md5( gTextRevert );
			var gUrl = 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&format=text&langpair=%7C' + currLocale + '&q=' + encodeURIComponent( gText );
			//alert( gText );
			jQuery.getJSON(gUrl,
				function( data ) {
					if( facebooktranslate.processResponseDataErrors( doc, data, _self, gTextRevert, fbtrid, 1 ) === false )
						return;
					
					if( data.responseData.translatedText != 'null' && data.responseStatus == 200 ) {
						//var transText = jQuery( _self, this ).hide().parent().find('.commentContent').html( data.responseData.translatedText );
						//var transText = jQuery( _self, doc ).parent().parent().parent().find('.commentContent').html( data.responseData.translatedText );
						var transText = jQuery( _self, doc ).hide().parent().parent().parent().find('.commentContent').contents().eq(1).wrap("<p />").parent().text( data.responseData.translatedText ).contents().unwrap();
						jQuery.data(doc, "fbtrid" + fbtrid, gTextRevert);
					} else {
						alert('Could not translate text!');
					}
			});
			return false;
		});
		
		jQuery('.fbtranslateblurbactionlink', doc).live('click', function( event ) {
			var _self = this;
			var gText = jQuery( this, doc ).parent().find('div.text_wrapper').text();
			var gTextRevert = jQuery( this, doc ).parent().find('div.text_wrapper').html();
			var fbtrid = facebooktranslate.md5( gTextRevert );
			var gUrl = 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&format=text&langpair=%7C' + currLocale + '&q=' + encodeURIComponent( gText );
			jQuery.getJSON(gUrl,
				function( data ) {
					if( facebooktranslate.processResponseDataErrors( doc, data, _self, gTextRevert, fbtrid, 2 ) === false )
						return;
					
					if( data.responseData.translatedText != 'null' && data.responseStatus == 200 ) {
						var transText = jQuery( _self, this ).hide().prev().html( data.responseData.translatedText );
						jQuery.data(doc, "fbtrid" + fbtrid, gTextRevert);
					} else {
						alert('Could not translate text!');
					}
			});
			return false;
		});
		
		jQuery('.fbuntranslatelink', doc).live('click', function( event ) {
			var fbtrid = jQuery( this, doc ).attr('id');
			var rText = jQuery.data(doc, fbtrid);
			
			jQuery( this, doc ).hide().prev().show();
			
			if( jQuery( this, doc ).hasClass('fbtstatus') ) {
				if( facebooktranslate.getFBSection( doc ) == 'profile' ) {
					jQuery( this, doc ).parentsUntil('#profile_minifeed').find('.UIStory_Message').html( rText );
				} else if( facebooktranslate.getFBSection( doc ) == 'home' ) {
					jQuery( this, doc ).parentsUntil('.UIImageBlock').find('.uiStreamMessage').html( rText );
				}
			} else if( jQuery( this, doc ).hasClass('fbtprofile') ) {
				jQuery( this, doc ).parent().find('div.text_wrapper').html( rText );
			} else if( jQuery( this, doc ).hasClass('fbtcomment') ) {
				//jQuery( this, doc ).parent().parent().find('.comment_actual_text').html( rText );
				jQuery( this, doc ).parent().parent().parent().find('.commentContent').contents().eq(1).wrap("<p />").parent().html( rText ).contents().unwrap();
				//alert( rText );
			}
			
			return false;
		});
		
		jQuery('.fbtranslateoptionlink', doc).live('click', function( event ) {
			window.openDialog("chrome://facebook-translate/content/options.xul", "", "chrome,toolbar,dialog,centerscreen,alwaysRaised");
			
			return false;
		});
	},
	
	processResponseDataErrors: function( doc, data, _self, r, fbtrid, type ) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService).
					getBranch("extensions.facebook-translate.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		prefs.addObserver("", this, false);
		var currLocale = prefs.getCharPref("localepref");
		
		var strings = document.getElementById("facebook-translate-strings");
		var noTranslation = strings.getString('noTranslation');
		var alreadyTargetLang = strings.getString('alreadyTargetLang');
		var untranslateLink = strings.getString('untranslateLink');
		var changleLocaleLink = strings.getString('changleLocaleLink');
		
		if( data.responseData == null ) {
			jQuery( _self, doc ).hide().parent().append( '<span style="background-color:#FFF9D7;padding:1px 2px;">' + noTranslation + '</span>' );
			return false;
		}
		
		if( data.responseData.detectedSourceLanguage == currLocale ) {
			jQuery( _self, doc ).hide().parent().append( '<span style="background-color:#FFF9D7;padding:1px 2px;">' + alreadyTargetLang + ' [' + currLocale.toUpperCase() + '] <a href="#" class="fbtranslateoptionlink">[' + changleLocaleLink + ']</a></span>' );
			return false;
		}
		
		if( type == 0 )
			var classname = ' fbtstatus';
		else if( type == 1 )
			var classname = ' fbtcomment';
		else if( type == 2 )
			var classname = ' fbtprofile';
		else
			var classname = '';
				
		jQuery( _self, doc ).hide().after( '<a href="#" class="item fbuntranslatelink' + classname + '" id="fbtrid' + fbtrid + '">' + untranslateLink + '</a>' );
		
		return true;
	},
	
	getTranslateLinkObject: function( doc, event ) {
		if( !jQuery.isXMLDoc( !jQuery.isXMLDoc( gBrowser.selectedBrowser.contentDocument ) ) ) {
			var facebookElements = new Array();
			facebookElementsTmp = jQuery("form.commentable_item > span.UIActionLinks_bottom", doc);
			for (infc = 0, jnfc = 0; infc < facebookElementsTmp.length; infc++) {
				if ( !jQuery( facebookElementsTmp[infc], doc ).hasClass("fbtranslate_updated") ) {
					facebookElements[jnfc] = facebookElementsTmp[infc];
					jnfc++;
				}
			}
			
			if ( facebookElements.length > 0 ) {
				facebooktranslate.setTranslateLinks( facebookElements, doc, event );
			}
			facebooktranslate.setTranslateCommentsLinks( doc, event );
		} else {
			return false;
		}
	},
	
	setTranslateLinks: function( facebookElements, doc, event ) {
		jQuery( facebookElements, doc ).addClass('fbtranslate_updated');
		for (indexdl=0; indexdl<facebookElements.length; indexdl++) {
			jQuery( facebookElements[indexdl], doc ).append( facebooktranslate.getTranslateLink( true, 'fbtranslateactionlink' ) );
		}
	},
	
	setTranslateCommentsLinks: function( doc, event ) {
		jQuery(".commentList .commentActions", doc).each(function( index ) {
			var hasLink = jQuery(this, doc).find('a.fbtranslatecommentactionlink');
			if( hasLink.length == 0 ) {
				jQuery(this, doc).append( facebooktranslate.getTranslateLink( true, 'fbtranslatecommentactionlink' ) );
			}
		});
	},
	
	getTranslateLink: function( seperator, classname ) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefService).
					getBranch("extensions.facebook-translate.");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		prefs.addObserver("", this, false);
		var currLocale = prefs.getCharPref("localepref");
		
		var strings = document.getElementById("facebook-translate-strings");
		var translateLinkText = strings.getString('translateLink');
		var translateToLabel = strings.getString('translateToLabel');
		var output = '';
		
		if( seperator )
			output += facebooktranslate.SEP;
		
		if( classname != '' )
			classname = ' ' + classname;
			
		output += '<a href="#" class="uiTooltip' + classname + '">' + translateLinkText + '<span class="uiTooltipWrap top"><span class="uiTooltipText">' + translateToLabel + ' ' + currLocale.toUpperCase() + '</span></span></a>';
		return output;
	},
	
	getFBSection: function( doc ) {
		if( jQuery("div#profile_stream_container", doc).length > 0 ) {
			return 'profile';
		} else if( jQuery("div#pagelet_intentional_stream", doc).length > 0 ) {
			return 'home';
		} else {
			return 'unknown';
		}
	},
	
	getMousePosition: function( event ) {
		if (!event) return {x:0, y:0};
	
		var mouseX = event.clientX || 0;
		var mouseY = event.clientY || 0;
	
		return {x: mouseX, y: mouseY};
	},
	
	utf8_encode: function( argString ) {
	    var string = (argString+''); // .replace(/\r\n/g, "\n").replace(/\r/g, "\n");
	
	    var utftext = "";
	    var start, end;
	    var stringl = 0;
	
	    start = end = 0;
	    stringl = string.length;
	    for (var n = 0; n < stringl; n++) {
	        var c1 = string.charCodeAt(n);
	        var enc = null;
	
	        if (c1 < 128) {
	            end++;
	        } else if (c1 > 127 && c1 < 2048) {
	            enc = String.fromCharCode((c1 >> 6) | 192) + String.fromCharCode((c1 & 63) | 128);
	        } else {
	            enc = String.fromCharCode((c1 >> 12) | 224) + String.fromCharCode(((c1 >> 6) & 63) | 128) + String.fromCharCode((c1 & 63) | 128);
	        }
	        if (enc !== null) {
	            if (end > start) {
	                utftext += string.substring(start, end);
	            }
	            utftext += enc;
	            start = end = n+1;
	        }
	    }
	
	    if (end > start) {
	        utftext += string.substring(start, string.length);
	    }
	
	    return utftext;
	},
	
	md5: function(str) {
	    var xl;
	
	    var rotateLeft = function (lValue, iShiftBits) {
	        return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
	    };
	
	    var addUnsigned = function (lX,lY) {
	        var lX4,lY4,lX8,lY8,lResult;
	        lX8 = (lX & 0x80000000);
	        lY8 = (lY & 0x80000000);
	        lX4 = (lX & 0x40000000);
	        lY4 = (lY & 0x40000000);
	        lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
	        if (lX4 & lY4) {
	            return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
	        }
	        if (lX4 | lY4) {
	            if (lResult & 0x40000000) {
	                return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
	            } else {
	                return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
	            }
	        } else {
	            return (lResult ^ lX8 ^ lY8);
	        }
	    };
	
	    var _F = function (x,y,z) { return (x & y) | ((~x) & z); };
	    var _G = function (x,y,z) { return (x & z) | (y & (~z)); };
	    var _H = function (x,y,z) { return (x ^ y ^ z); };
	    var _I = function (x,y,z) { return (y ^ (x | (~z))); };
	
	    var _FF = function (a,b,c,d,x,s,ac) {
	        a = addUnsigned(a, addUnsigned(addUnsigned(_F(b, c, d), x), ac));
	        return addUnsigned(rotateLeft(a, s), b);
	    };
	
	    var _GG = function (a,b,c,d,x,s,ac) {
	        a = addUnsigned(a, addUnsigned(addUnsigned(_G(b, c, d), x), ac));
	        return addUnsigned(rotateLeft(a, s), b);
	    };
	
	    var _HH = function (a,b,c,d,x,s,ac) {
	        a = addUnsigned(a, addUnsigned(addUnsigned(_H(b, c, d), x), ac));
	        return addUnsigned(rotateLeft(a, s), b);
	    };
	
	    var _II = function (a,b,c,d,x,s,ac) {
	        a = addUnsigned(a, addUnsigned(addUnsigned(_I(b, c, d), x), ac));
	        return addUnsigned(rotateLeft(a, s), b);
	    };
	
	    var convertToWordArray = function (str) {
	        var lWordCount;
	        var lMessageLength = str.length;
	        var lNumberOfWords_temp1=lMessageLength + 8;
	        var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
	        var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
	        var lWordArray=new Array(lNumberOfWords-1);
	        var lBytePosition = 0;
	        var lByteCount = 0;
	        while ( lByteCount < lMessageLength ) {
	            lWordCount = (lByteCount-(lByteCount % 4))/4;
	            lBytePosition = (lByteCount % 4)*8;
	            lWordArray[lWordCount] = (lWordArray[lWordCount] | (str.charCodeAt(lByteCount)<<lBytePosition));
	            lByteCount++;
	        }
	        lWordCount = (lByteCount-(lByteCount % 4))/4;
	        lBytePosition = (lByteCount % 4)*8;
	        lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
	        lWordArray[lNumberOfWords-2] = lMessageLength<<3;
	        lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
	        return lWordArray;
	    };
	
	    var wordToHex = function (lValue) {
	        var wordToHexValue="",wordToHexValue_temp="",lByte,lCount;
	        for (lCount = 0;lCount<=3;lCount++) {
	            lByte = (lValue>>>(lCount*8)) & 255;
	            wordToHexValue_temp = "0" + lByte.toString(16);
	            wordToHexValue = wordToHexValue + wordToHexValue_temp.substr(wordToHexValue_temp.length-2,2);
	        }
	        return wordToHexValue;
	    };
	
	    var x=[],
	        k,AA,BB,CC,DD,a,b,c,d,
	        S11=7, S12=12, S13=17, S14=22,
	        S21=5, S22=9 , S23=14, S24=20,
	        S31=4, S32=11, S33=16, S34=23,
	        S41=6, S42=10, S43=15, S44=21;
	
	    str = facebooktranslate.utf8_encode(str);
	    x = convertToWordArray(str);
	    a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
	    
	    xl = x.length;
	    for (k=0;k<xl;k+=16) {
	        AA=a; BB=b; CC=c; DD=d;
	        a=_FF(a,b,c,d,x[k+0], S11,0xD76AA478);
	        d=_FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
	        c=_FF(c,d,a,b,x[k+2], S13,0x242070DB);
	        b=_FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
	        a=_FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
	        d=_FF(d,a,b,c,x[k+5], S12,0x4787C62A);
	        c=_FF(c,d,a,b,x[k+6], S13,0xA8304613);
	        b=_FF(b,c,d,a,x[k+7], S14,0xFD469501);
	        a=_FF(a,b,c,d,x[k+8], S11,0x698098D8);
	        d=_FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
	        c=_FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
	        b=_FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
	        a=_FF(a,b,c,d,x[k+12],S11,0x6B901122);
	        d=_FF(d,a,b,c,x[k+13],S12,0xFD987193);
	        c=_FF(c,d,a,b,x[k+14],S13,0xA679438E);
	        b=_FF(b,c,d,a,x[k+15],S14,0x49B40821);
	        a=_GG(a,b,c,d,x[k+1], S21,0xF61E2562);
	        d=_GG(d,a,b,c,x[k+6], S22,0xC040B340);
	        c=_GG(c,d,a,b,x[k+11],S23,0x265E5A51);
	        b=_GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
	        a=_GG(a,b,c,d,x[k+5], S21,0xD62F105D);
	        d=_GG(d,a,b,c,x[k+10],S22,0x2441453);
	        c=_GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
	        b=_GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
	        a=_GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
	        d=_GG(d,a,b,c,x[k+14],S22,0xC33707D6);
	        c=_GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
	        b=_GG(b,c,d,a,x[k+8], S24,0x455A14ED);
	        a=_GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
	        d=_GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
	        c=_GG(c,d,a,b,x[k+7], S23,0x676F02D9);
	        b=_GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
	        a=_HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
	        d=_HH(d,a,b,c,x[k+8], S32,0x8771F681);
	        c=_HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
	        b=_HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
	        a=_HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
	        d=_HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
	        c=_HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
	        b=_HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
	        a=_HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
	        d=_HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
	        c=_HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
	        b=_HH(b,c,d,a,x[k+6], S34,0x4881D05);
	        a=_HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
	        d=_HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
	        c=_HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
	        b=_HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
	        a=_II(a,b,c,d,x[k+0], S41,0xF4292244);
	        d=_II(d,a,b,c,x[k+7], S42,0x432AFF97);
	        c=_II(c,d,a,b,x[k+14],S43,0xAB9423A7);
	        b=_II(b,c,d,a,x[k+5], S44,0xFC93A039);
	        a=_II(a,b,c,d,x[k+12],S41,0x655B59C3);
	        d=_II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
	        c=_II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
	        b=_II(b,c,d,a,x[k+1], S44,0x85845DD1);
	        a=_II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
	        d=_II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
	        c=_II(c,d,a,b,x[k+6], S43,0xA3014314);
	        b=_II(b,c,d,a,x[k+13],S44,0x4E0811A1);
	        a=_II(a,b,c,d,x[k+4], S41,0xF7537E82);
	        d=_II(d,a,b,c,x[k+11],S42,0xBD3AF235);
	        c=_II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
	        b=_II(b,c,d,a,x[k+9], S44,0xEB86D391);
	        a=addUnsigned(a,AA);
	        b=addUnsigned(b,BB);
	        c=addUnsigned(c,CC);
	        d=addUnsigned(d,DD);
	    }
	
	    var temp = wordToHex(a)+wordToHex(b)+wordToHex(c)+wordToHex(d);
	
	    return temp.toLowerCase();
	}
};

window.addEventListener("load", facebooktranslate.onFirefoxLoad, false);